#!/bin/tcsh

set CovenDRIVER_BASE = "$HOME/coven-engine/"
set MODULES_SRC_DIR = "modules"
set CovenSRC = "src"
#set RACLIB = "/home/ndebard/libRAC.so"
set BINDIR = "bin"
set MODULESDIR = "bin/modules"

if ($# != 3 ) then
	echo "Syntax: $0 <num slave processors> <num master tasks> <num slave tasks>"
	exit
endif

set SCYLD = 0
set BALLOC = 0
if (-e /etc/scyld-release) then
	echo "Scyld Beowulf system detected."
	cat /etc/scyld-release
	set SCYLD = 1
endif

if (-e /etc/balloc/setmgr/sets.db) then
	echo "Balloc Beowulf system detected."
	set BALLOC = 1
endif

cd $CovenDRIVER_BASE/$CovenSRC
make clean
make
rm -f $CovenDRIVER_BASE/$BINDIR/coven_program.so
cp coven-engine coven_program.so $CovenDRIVER_BASE/$BINDIR
#cp $RACLIB $CovenDRIVER_BASE/$BINDIR
rm -f $CovenDRIVER_BASE/$MODULESDIR/*.so
cp $MODULES_SRC_DIR/*.so $CovenDRIVER_BASE/$MODULESDIR
sync
cd $CovenDRIVER_BASE/$BINDIR
# numslaves is the number of slave processors to use.  Each slave processor
# will have $3 processes running on it.  Additionally, there will be a master
# process with $2 processes running on it.
set numslaves = $1
set numprocs = `expr $numslaves + 1`

if ( $BALLOC == 1 ) then
	# create the set for balloc 
	echo "Running: setmgr -c coven-driver-run.sh_set -n $numprocs"
	setmgr -c coven-driver-run.sh_set -n $numprocs
	./coven-scyld-mpirun.py -bset coven-driver-run.sh_set -np $numslaves -m $2 -s $3 coven-engine
	setmgr -d coven-driver-run.sh_set
else
	./coven-mpirun.py -np $numslaves -m $2 -s $3 coven-engine
endif
