#!/usr/bin/python
# Nathan DeBardeleben
# March 5, 2002
#
#   A frontend to mpirun so that you can specify the number of processors 
#   plus the number of MPI tasks on the "head" process and the number of MPI
#   tasks on each "slave" process.  Other mpirun calls can still be passed
#   through as the last argument.

import sys, string, re, os

help = sys.argv[0]+" -np <# procs> -m <# of master "\
	"tasks> -s <# of slave "\
	"tasks> <other mpirun arguments plus MPI program with arguments>"

np_set = m_set = s_set = 0
myranet = 0

if '-h' in sys.argv or '-help' in sys.argv or '--h' in sys.argv or '--help' \
in sys.argv:
	print help
	sys.exit(0)

if len(sys.argv) < 6:
	print help
	sys.exit(0)

mpi_command = ""

for i in range(len(sys.argv)):
	if sys.argv[i] == "-np":
		np_set = sys.argv[i+1]
	if sys.argv[i] == "-m":
		m_set = sys.argv[i+1]
	if sys.argv[i] == "-s":
		s_set = sys.argv[i+1]
	if i >= 7:
		mpi_command = mpi_command + sys.argv[i] + " "

if np_set == 0 or m_set == 0 or s_set == 0:
	print help
	sys.exit(0)

num_mpi_tasks = string.atoi(m_set) + (string.atoi(np_set) * \
	string.atoi(s_set))

#myranet = 1
mf = open(os.environ['HOME']+"/Coven-machinefile")
tmp_mf = open("/tmp/Coven-machinefile.tmp","w")
line = 0;
for orig_line in mf.readlines():
	p = re.compile(r'\012')
	subline = p.split(orig_line)
	realline = subline[0]
	line = line + 1
	if line == 1:
		for i in range(string.atoi(m_set)):
			if myranet == 1:
				tmp_mf.write(realline+"-myr\n")
			else:
				tmp_mf.write(realline+"\n")
	else:
		for i in range(string.atoi(s_set)):
			if myranet == 1:
				tmp_mf.write(realline+"-myr\n")
			else:
				tmp_mf.write(realline+"\n")
mf.close()
tmp_mf.close()
mpi_run_command = "mpirun -machinefile /tmp/Coven-machinefile.tmp -np "+str(num_mpi_tasks)+" "+mpi_command

print "Executing: "+mpi_run_command
os.system(mpi_run_command)

#os.unlink("/tmp/Coven-machinefile.tmp")
