#!/usr/bin/python
# Nathan DeBardeleben
# March 5, 2002
#
#   A frontend to mpirun so that you can specify the number of processors 
#   plus the number of MPI tasks on the "head" process and the number of MPI
#   tasks on each "slave" process.  Other mpirun calls can still be passed
#   through as the last argument.

import sys, string, re, os

help = sys.argv[0]+" -bset <balloc set name> -np <# procs> -m <# of master "\
	"tasks> -s <# of slave "\
	"tasks> <other mpirun arguments plus MPI program with arguments>"

np_set = m_set = s_set = 0
bset_set = " "
myranet = 0

if '-h' in sys.argv or '-help' in sys.argv or '--h' in sys.argv or '--help' \
in sys.argv:
	print help
	sys.exit(0)

if len(sys.argv) < 8:
	print help
	sys.exit(0)

mpi_command = ""

for i in range(len(sys.argv)):
	if sys.argv[i] == "-bset":
		bset_set = sys.argv[i+1]
	if sys.argv[i] == "-np":
		np_set = sys.argv[i+1]
	if sys.argv[i] == "-m":
		m_set = sys.argv[i+1]
	if sys.argv[i] == "-s":
		s_set = sys.argv[i+1]
	if i >= 9:
		mpi_command = mpi_command + sys.argv[i] + " "

if bset_set == "" or np_set == 0 or m_set == 0 or s_set == 0:
	print help
	sys.exit(0)

machines = []

for i in range((string.atoi(m_set))):
	machines.append(0)
slave_num = 1
for i in range((string.atoi(np_set))):
	for j in range((string.atoi(s_set))):
		machines.append(slave_num)
	slave_num = slave_num + 1

map_str = " "

for val in machines:
	map_str = map_str + str(val) +":"

mpi_run_command = "mpirun -bset "+bset_set+" -map \""+map_str+"\" "+mpi_command
print "CMD: "+mpi_run_command

print "Executing: "+mpi_run_command
os.system(mpi_run_command)
