
/*
 * (C) 2002 Clemson University and The University of Chicago.
 *
 * See COPYING in top-level directory.
 */

#ifndef __COVEN_REQUEST_H
#define __COVEN_REQUEST_H

#include <coven_types.h>

typedef struct CINT_Type *COVEN_Type;

int COVEN_Type_contiguous(COVEN_count count, COVEN_Type oldtype,
		      COVEN_Type *newtype);

int COVEN_Type_vector(COVEN_count count, COVEN_size blocklength,
				COVEN_size stride, COVEN_Type oldtype, COVEN_Type *newtype);

int COVEN_Type_hvector(COVEN_count count, COVEN_size blocklength,
				COVEN_offset stride, COVEN_Type oldtype, COVEN_Type *newtype);

int COVEN_Type_indexed(COVEN_count count, COVEN_size *blocklengths,
		      COVEN_offset *displacements, COVEN_Type oldtype,
				COVEN_Type *newtype);

int COVEN_Type_hindexed(COVEN_count count, COVEN_size *blocklengths,
				COVEN_offset *displacements, COVEN_Type oldtype,
				COVEN_Type *newtype);

int COVEN_Type_struct(COVEN_count count, COVEN_size *blocklengths,
				COVEN_offset *displacements, COVEN_Type *oldtypes,
				COVEN_Type *newtype);

int COVEN_Address(void* location, COVEN_offset *address);

int COVEN_Type_extent(COVEN_Type datatype, COVEN_size *extent);

int COVEN_Type_size(COVEN_Type datatype, COVEN_size *size);

int COVEN_Type_lb(COVEN_Type datatype, COVEN_offset *displacement);

int COVEN_Type_ub(COVEN_Type datatype, COVEN_offset *displacement);

/* pre-defined datatype types */
extern COVEN_Type COVEN_CHAR;
extern COVEN_Type COVEN_SHORT;
extern COVEN_Type COVEN_INT;
extern COVEN_Type COVEN_LONG;
extern COVEN_Type COVEN_UNSIGNED_CHAR;
extern COVEN_Type COVEN_UNSIGNED_SHORT;
extern COVEN_Type COVEN_UNSIGNED_INT;
extern COVEN_Type COVEN_UNSIGNED_LONG;
extern COVEN_Type COVEN_FLOAT;
extern COVEN_Type COVEN_DOUBLE;
extern COVEN_Type COVEN_LONG_DOUBLE;
extern COVEN_Type COVEN_BYTE;
extern COVEN_Type COVEN_PACKED;

#endif /* __COVEN_REQUEST_H */
