/*
 * debug.h copyright (c) 1998-2000 Nathan DeBardeleben, all rights reserved.
 *
 * Written by Nathan DeBardeleben. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Contact:  Nathan DeBardeleben   ndebard@parl.clemson.edu
 */

#ifndef __COVEN_DEBUG_H
#define __COVEN_DEBUG_H

/*
debugging macros
*/

//#define TRACE 1
#if TRACE
#define trace(s) do{printf(s);fflush(stdout);}while(0)
#define trace1(s,d) do{printf(s,d);fflush(stdout);}while(0)
#define trace2(s,d,k) do{printf(s,d,k);fflush(stdout);}while(0)
#define trace3(s,d,k,r) do{printf(s,d,k,r);fflush(stdout);}while(0)
#define trace4(s,d,k,r,u) do{printf(s,d,k,r,u);fflush(stdout);}while(0)
#define trace5(s,d,k,r,u,t) do{printf(s,d,k,r,u,t);fflush(stdout);}while(0)
#define trace6(s,d,k,r,u,t,v) do{printf(s,d,k,r,u,t,v);fflush(stdout);}while(0)
#define tfile do{char file[]="/tmp/bnm_trace.XXXXXX";umask(0);dup2(mkstemp(file),2);}while(0)
/*
#define trace(s) do{fputs((s),stdout);fflush(stdout);}while(0)
#define trace1(s,d) do{fprintf(stdout,s,d);fflush(stdout);}while(0)
#define trace2(s,d,k) do{fprintf(stdout,s,d,k);fflush(stdout);}while(0)
#define trace3(s,d,k,r) do{fprintf(stdout,s,d,k,r);fflush(stdout);}while(0)
#define trace4(s,d,k,r,u) do{fprintf(stdout,s,d,k,r,u);fflush(stdout);}while(0)
#define trace5(s,d,k,r,u,t) do{fprintf(stdout,s,d,k,r,u,t);fflush(stdout);}while(0)
#define trace6(s,d,k,r,u,t,v) do{fprintf(stdout,s,d,k,r,u,t,v);fflush(stdout);}while(0)
#define tfile do{char file[]="/tmp/bnm_trace.XXXXXX";umask(0);dup2(mkstemp(file),2);}while(0)
*/
#else
#define trace(s)
#define trace1(s,d)
#define trace2(s,d,k)
#define trace3(s,d,k,r)
#define trace4(s,d,k,r,u)
#define trace5(s,d,k,r,u,t)
#define trace6(s,d,k,r,u,t,v)
#define tfile do {dup2(open("/dev/null",O_WRONLY),2);}while(0)
#endif

#endif /* __COVEN_DEBUG_H */
