/*
 * (C) 2001 Clemson University and The University of Chicago
 *
 * See COPYING in top-level directory.
 */

/* COVEN Types
 */

#ifndef __COVEN_TYPES_H
#define __COVEN_TYPES_H

#include <stdint.h>
#include <time.h>

typedef char * COVEN_CHAR_BUFFER_TYPE;
typedef unsigned char * COVEN_UCHAR_BUFFER_TYPE;
typedef short * COVEN_SHORT_BUFFER_TYPE;
typedef unsigned short * COVEN_USHORT_BUFFER_TYPE;
typedef int * COVEN_INT_BUFFER_TYPE;
typedef unsigned int * COVEN_UINT_BUFFER_TYPE;
typedef float * COVEN_FLOAT_BUFFER_TYPE;
typedef double * COVEN_DOUBLE_BUFFER_TYPE;

#define COVEN_CHAR_BUFFER  		0
#define COVEN_UCHAR_BUFFER 		1  
#define COVEN_SHORT_BUFFER 		2
#define COVEN_USHORT_BUFFER		3
#define COVEN_INT_BUFFER   		4
#define COVEN_UINT_BUFFER  		5
#define COVEN_FLOAT_BUFFER 		6
#define COVEN_DOUBLE_BUFFER		7

#define COVEN_SCATTER 0
#define COVEN_GATHER 1
#define COVEN_SEEK 2

typedef struct COVEN_TPH *COVEN_TPH;
typedef struct COVEN_Buffer *COVEN_Buffer;

typedef char *COVEN_string;
typedef uint8_t COVEN_boolean;
typedef int64_t COVEN_offset;
typedef int64_t COVEN_size;
typedef uint32_t COVEN_bitfield;
typedef int32_t COVEN_flag;
typedef int32_t COVEN_count;
typedef int32_t COVEN_count32;
typedef int64_t COVEN_count64;
typedef uint64_t COVEN_volume_id;
typedef uint64_t COVEN_flow_id;
typedef int64_t COVEN_handle;
typedef int32_t COVEN_fs_id;

typedef int32_t COVEN_error;
typedef int32_t COVEN_magic;
typedef uint32_t COVEN_uid;
typedef uint32_t COVEN_gid;
typedef uint32_t COVEN_permissions;
typedef int64_t COVEN_token;
typedef time_t COVEN_time;

#endif /* __COVEN_TYPES_H */
