/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

void Hecate_Get_Cart(MPI_Comm init_comm, MPI_Comm *new_comm,
  int NPX, int NPY,
  int *my_x_coord, int *my_y_coord, int *nxminus, int *nxplus, 
  int *nyminus, int *nyplus)
{
	int idims[2], periods[2], icoords[2];
	int reorder;

	/* define 2d array of periodic processors */
	idims[0] = NPX;
	idims[1] = NPY;
	periods[0] = TRUE;
	periods[1] = TRUE;
	reorder = TRUE;

	/* hardware optimized processor configurator and new ranking */
	MPI_Cart_create(init_comm, 2, idims, periods, 
	  reorder, new_comm);

	/* find nearest neighbor ranks */
	MPI_Cart_shift(*new_comm, 0, 1, nxminus, nxplus);
	MPI_Cart_shift(*new_comm, 1, 1, nyminus, nyplus);
	MPI_Cart_get(*new_comm, 2, idims, periods, icoords);

	*my_x_coord = icoords[0];
	*my_y_coord = icoords[1];
}
