/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include "coven.h"
#include <string.h>

char * COVEN_Get_Global_Binding(
  struct COVEN_Mod_Binding_Table *btable,
  char *local_binding)
{
	char *res = NULL;
	int start, cur, done, found;

	COVEN_debug(DARGS, "Looking for GB for LB '%s'\n", local_binding);

	found = FALSE;
	done = FALSE;
	/* start where we last looked */
	start = btable->try_here;
	cur = start;
	do {
	    /* do a strcmp to see if the local binding we're looking for is 
	     * this element of the table */
	    if(!(strcmp(local_binding, btable->bindings[cur].local_binding))) {
		res = btable->bindings[cur].global_binding;
		found = TRUE;
		done = TRUE;
	    }
		
	    cur++;
	    /* if we've reached the end of the table, then loop to the front
	     * and check there */ 
	    if(cur >= btable->num_bindings) cur = 0;
	    /* but what if we've made a complete loop and still not found it,
	     * then we've got to break out of this */
	    if(cur == start && found == FALSE) { /* we've looped around */
	        found = FALSE;
		done = TRUE;
	    }
	    /* set where to try next time so that we can hopefully cut down
	     * on search time */
	    btable->try_here = cur;
	} while(!done);
	
	if(res != NULL && found == TRUE) 
	    COVEN_debug(DARGS, "  found GB name '%s'\n", res);
	return res;
}
