/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include "coven.h"
#include <unistd.h>
#include <errno.h>

int COVEN_write(int fd, const void *buf, int count)
{
	int ret, complete;

	complete = count;

	while(complete) {
COVEN_write_restart:
	    ret = write(fd, buf, complete);
	    if(ret == -1 && errno == EINTR) {
		trace("\tCOVEN_write: EINTR caught, looping.\n");
		goto COVEN_write_restart;
	    }
	    else if(ret == -1) {
		COVEN_Error("COVEN_write: FATAL ERROR, write returned -1: ");
	    }
	    complete -= ret;
	    buf = (char *) buf + ret;
	}

	return (count - complete);
}

int COVEN_read(int fd, void *buf, int count)
{
	int ret, complete;

	complete = count;

	while(complete) {
COVEN_read_restart:
	    ret = read(fd, buf, complete);
	    if(ret == -1 && errno == EINTR) {
		trace("\tCOVEN_read: EINTR caught, looping.\n");
		goto COVEN_read_restart;
	    }
	    else if(ret == -1) {
		COVEN_Error("COVEN_read: FATAL ERROR, read returned -1: ");
	    }
	    complete -= ret;  
	    buf = (char *) buf + ret;
	}

	return (count - complete);
}
