/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include "coven.h"

void * COVEN_Get_Attrib_Arg(struct COVEN_Attribute_Table *at,
  struct COVEN_Mod_Binding_Table *btable, char *local_binding)
{
	char *tag;
	/* we need to find the global binding (tag name in the TPH) for the
	 * local binding within this binding table */
	COVEN_debug(DARGS, "Get_Attrib_Arg(): Looking for GB for LB '%s'\n",
	  local_binding);
	tag = COVEN_Get_Global_Binding(btable, local_binding);
	return COVEN_Attribute_Table_Get_Attrib_Data(at, tag);
}

void * COVEN_Put_Attrib_Arg(struct COVEN_Attribute_Table *at,
  struct COVEN_Mod_Binding_Table *btable, char *local_binding, int type,
  int size)
{
   	char *tag;
	/* we need to find the global binding (tag name in the TPH) for the
	 * local binding within this binding table */
	COVEN_debug(DARGS, "Put_Attrib_Arg(): Looking for GB for LB '%s'\n",
	  local_binding);
	tag = COVEN_Get_Global_Binding(btable, local_binding);
	return COVEN_Attribute_Table_Put_Attrib_Data(at, tag, type, size);
}

void * COVEN_Put_Ptr_Attrib_Arg(struct COVEN_Attribute_Table *at,
  struct COVEN_Mod_Binding_Table *btable, char *local_binding, int type,
  int size)
{
   	char *tag;
	/* we need to find the global binding (tag name in the TPH) for the
	 * local binding within this binding table */
	COVEN_debug(DARGS, "Put_Ptr_Attrib_Arg(): Looking for GB for LB '%s'\n",
	  local_binding);
	tag = COVEN_Get_Global_Binding(btable, local_binding);
	return COVEN_Attribute_Table_Get_Or_Create_Attrib_Data(at, tag, type, size);
}

void * COVEN_Get_Buffer_Arg(
  struct COVEN_TPH *tph,
  struct COVEN_Mod_Binding_Table *btable,
  char *local_binding,
  int pmode,
  int ptype,
  int psize)
{

	struct COVEN_Buffer *buf;
	char *tag;

	COVEN_debug(DARGS, "- Get_Buffer_Arg alive!\n");

	/* we need to find the global binding (tag name in the TPH) for the
	 * local binding within this binding table */
	tag = COVEN_Get_Global_Binding(btable, local_binding);
	COVEN_debug(DARGS, "- Get_Buffer_Arg found the tag!\n");
	
	switch (pmode) {

	    case COVEN_INPUT_MODE : case COVEN_INOUT_MODE :
		buf = COVEN_Get_Buffer(tph, tag, ptype);
		if(!buf) {
		    gossip_err(
		      "      ERROR: tag `%s' not found as INPUT or INOUT "
		      "mode.\n", tag);
		}
		else {
		    COVEN_Print_TPH(tph);
		    COVEN_debug(DARGS, "Get_Buffer_Arg(): Returning data of "
		      "LB '%s' buffer.\n", local_binding);
		    return COVEN_Buffer_Data(buf);
		}
		break;
		
	    /* if the buffer already exists, just hand back a pointer to it */
	    case COVEN_OUTPUT_MODE :
		/* this assumes psize is the number of bytes */
		buf = COVEN_Get_Buffer(tph, tag, ptype);
		if(!buf) {
		    COVEN_debug(DARGS, "Tag `%s' not found as OUTPUT, "
		      "allocating %d elements.\n",
		       tag, psize);
		    buf = COVEN_New_Buffer(tph, tag, psize, ptype);
		}
		/* I guess we should check and make certain that it's the 
		 * same type and size */
		else {
		    COVEN_debug(DARGS, "FUCKING CISHDEFHJIWEIHR@#H$JI@#E$@#\n");
		    COVEN_debug(DARGS, "MODARG!: Replacing old buffer of "
		      "size,type = %d,%d w/ size,type = %d,%d\n",
		      buf->size, buf->type, psize, ptype);
		    COVEN_debug(DARGS, "ASDFkjSkj BEFORFE!\n");
		    COVEN_Print_TPH(tph);
		    COVEN_debug(DARGS, "ASDFkjSkj ADSFTER!!\n");

		    /* THIS CAUSES A SEG FAULT, THIS IS THE PROBLEM! */
		    buf = COVEN_Do_Buffer_Data_Replace(local_binding, tph, btable,
		      NULL, psize);
		    COVEN_Print_TPH(tph);
		}
		return COVEN_Buffer_Data(buf);
		break;
	}
	return NULL;
}
