/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include "coven.h"

struct COVEN_Mod_Decl _coven_mod_decl_array[] = {
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_generate_planar_randY.so", 
    "nbody_generate_planar_randY"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_scatter.so", 
    "nbody_scatter"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_copy_buffer.so", 
    "nbody_copy_buffer"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_compute_forces.so", 
    "nbody_compute_forces"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_parallel_shift.so", 
    "nbody_parallel_shift"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_compute_positions.so", 
    "nbody_compute_positions"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_visualize.so", 
    "nbody_visualize"
  },
  {
    "/home/ndebard/Coven/CovenDriver/bin/modules//nbody_gather.so", 
    "nbody_gather"
  },
};

struct COVEN_Mods _coven_mods = {
  8, _coven_mod_decl_array
};

struct COVEN_Const_Decl _coven_constant_array[] = {
  {COVEN_INT, "__total_num_bodies", "900"},
  {COVEN_INT, "__num_processors", "2"},
  {COVEN_FLOAT, "__grid_spacing", "0.500000"},
  {COVEN_FLOAT, "__body_mass", "0.050000"},
  {COVEN_FLOAT, "__gravitational_constant", "66.730000"},
  {COVEN_FLOAT, "__min_collision_distance", "0.010000"},
  {COVEN_FLOAT, "__timestep", "0.001000"},
  {COVEN_STRING, "__vis_hostname", "130.127.24.33"},
  {COVEN_INT, "__vis_portnumber", "12345"},
  {COVEN_INT, "__loop_max_iterations", "10"},
};

struct COVEN_Consts _coven_constants = {
  10, 
  _coven_constant_array
};

struct COVEN_Mod_Binding _nbody_generate_planar_randY_1_array[] = {
  {"total_num_bodies", "__total_num_bodies"},
  {"num_processors", "__num_processors"},
  {"grid_spacing", "__grid_spacing"},
  {"body_mass", "__body_mass"},
  {"my_bodies", "nbody_generate_planar_randY_my_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_generate_planar_randY_1 = {
  5,
  0,
  _nbody_generate_planar_randY_1_array
};

struct COVEN_Mod_Binding _nbody_scatter_1_array[] = {
  {"num_slave_procs", "__num_processors"},
  {"my_bodies", "nbody_generate_planar_randY_my_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_scatter_1 = {
  2,
  0,
  _nbody_scatter_1_array
};

struct COVEN_Mod_Binding _nbody_copy_buffer_1_array[] = {
  {"my_bodies", "nbody_generate_planar_randY_my_bodies"},
  {"shift_bodies", "nbody_copy_buffer_shift_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_copy_buffer_1 = {
  2,
  0,
  _nbody_copy_buffer_1_array
};

struct COVEN_Mod_Binding _nbody_compute_forces_1_array[] = {
  {"gravitational_constant", "__gravitational_constant"},
  {"min_collision_distance", "__min_collision_distance"},
  {"timestep", "__timestep"},
  {"my_bodies", "nbody_generate_planar_randY_my_bodies"},
  {"shift_bodies", "nbody_copy_buffer_shift_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_compute_forces_1 = {
  5,
  0,
  _nbody_compute_forces_1_array
};

struct COVEN_Mod_Binding _nbody_parallel_shift_1_array[] = {
  {"shift_bodies", "nbody_copy_buffer_shift_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_parallel_shift_1 = {
  1,
  0,
  _nbody_parallel_shift_1_array
};

struct COVEN_Loop _coven_loop_2 = {
  "__loop_step",
  1,
  COVEN_LEQ,
  "__num_processors",
  1,
  3,
  4,
};

struct COVEN_Mod_Binding _nbody_compute_positions_1_array[] = {
  {"timestep", "__timestep"},
  {"my_bodies", "nbody_generate_planar_randY_my_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_compute_positions_1 = {
  2,
  0,
  _nbody_compute_positions_1_array
};

struct COVEN_Mod_Binding _nbody_visualize_1_array[] = {
  {"timestep", "__timestep"},
  {"vis_hostname", "__vis_hostname"},
  {"vis_portnumber", "__vis_portnumber"},
  {"total_num_bodies", "__total_num_bodies"},
  {"num_slave_procs", "__num_processors"},
  {"current_iteration", "__loop_iteration"},
  {"my_bodies", "nbody_generate_planar_randY_my_bodies"},
  {"visualization_socket", "__visualization_socket"},
};

struct COVEN_Mod_Binding_Table _nbody_visualize_1 = {
  8,
  0,
  _nbody_visualize_1_array
};

struct COVEN_Loop _coven_loop_1 = {
  "__loop_iteration",
  1,
  COVEN_LEQ,
  "__loop_max_iterations",
  1,
  2,
  6,
};

struct COVEN_Mod_Binding _nbody_gather_1_array[] = {
  {"total_num_bodies", "__total_num_bodies"},
  {"num_slave_procs", "__num_processors"},
  {"to_gather_bodies", "nbody_generate_planar_randY_my_bodies"},
};

struct COVEN_Mod_Binding_Table _nbody_gather_1 = {
  3,
  0,
  _nbody_gather_1_array
};

struct COVEN_Mod_Call _coven_mod_call_array[] = {
  {"nbody_generate_planar_randY", MASTER, 1, &_nbody_generate_planar_randY_1, NULL},
  {"nbody_scatter", MASTER, 2, &_nbody_scatter_1, NULL},
  {"nbody_copy_buffer", SLAVE, 1, &_nbody_copy_buffer_1, &_coven_loop_1},
  {"nbody_compute_forces", SLAVE, 2, &_nbody_compute_forces_1, &_coven_loop_2},
  {"nbody_parallel_shift", SLAVE, 3, &_nbody_parallel_shift_1, &_coven_loop_2},
  {"nbody_compute_positions", SLAVE, 4, &_nbody_compute_positions_1, NULL},
  {"nbody_visualize", SLAVE, 5, &_nbody_visualize_1, &_coven_loop_1},
  {"nbody_gather", MASTER, 3, &_nbody_gather_1, NULL},
};

struct COVEN_Mod_Calls _coven_mod_calls = {
  8,
  _coven_mod_call_array,
};

struct COVEN_Program _coven_program = {
  3,
  5,
  &_coven_constants,
  &_coven_mods,
  &_coven_mod_calls,
};
