/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include "coven.h"
#include <stdlib.h>
#include <string.h>

void COVEN_Update_Tag_Usage(char *tag, int stepnum,
  struct COVEN_Tag_Usage *tagusage)
{
	struct COVEN_Tag_Usage *find;
	find = COVEN_Find_Tag_Usage(tag, tagusage);
	if(find != NULL) {
	    if(stepnum > find->last_used) find->last_used = stepnum;
	}
	else {
	    COVEN_Add_Tag_Usage(tag, stepnum, tagusage);
	}
}

int COVEN_Find_Last_Used(char *tag, struct COVEN_Tag_Usage *tagusage) 
{
	struct COVEN_Tag_Usage *cur = tagusage;

	while(cur != NULL) {
	    if(!strcmp(tag, cur->tagname)) return cur->last_used;
	    cur = cur->next;
	}

	/* didn't find it, what the hell? */
	return -1;
}

struct COVEN_Tag_Usage* COVEN_Find_Tag_Usage(char *tag, 
  struct COVEN_Tag_Usage *tagusage)
{
	struct COVEN_Tag_Usage *cur = tagusage;

	while(cur != NULL) {
	    if(!strcmp(tag, cur->tagname)) return cur;
	    cur = cur->next;
	}

	return NULL;
}

void COVEN_Add_Tag_Usage(char *tag, int stepnum, 
  struct COVEN_Tag_Usage *tagusage)
{
	struct COVEN_Tag_Usage *cur = tagusage;
	struct COVEN_Tag_Usage *new;

	if(cur != NULL) {
	    while(cur->next != NULL) cur = cur->next;
	}
	/* cur is now the tail */
	new = (struct COVEN_Tag_Usage*)COVEN_malloc(sizeof(struct COVEN_Tag_Usage));
	new->tagname = (char*)COVEN_malloc(strlen(tag)+1);
	strcpy(new->tagname, tag);
	new->last_used = stepnum;
	new->next = NULL;
	if(cur != NULL) cur->next = new;
	else tagusage = new;
}

void COVEN_Print_Tag_Usage(struct COVEN_Tag_Usage *tagusage)
{
	struct COVEN_Tag_Usage *cur = tagusage;

	while(cur != NULL) {
	    printf("TAG: %s\tLAST USED MODULE #: %d\n", cur->tagname, 
	      cur->last_used);
	    cur = cur->next;
	}
}
