/*
 * (C) 2003 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include "coven.h"
#include <stdlib.h>

extern struct COVEN_TPH_Queue q;

void COVEN_Enqueue_TPH(struct COVEN_TPH *tph)
{
	struct COVEN_TPH_Queue_Element *oldback, *newback;

	oldback = q.back;
	newback = COVEN_malloc(sizeof(struct COVEN_TPH_Queue_Element));
	newback->tph = tph;
	newback->behind = NULL;
	if(oldback == NULL) /* q is empty */
	    q.back = newback;
	else {
	    oldback->behind = newback;
	    newback->infront = oldback;
	    q.back = newback;
	}
	if(q.front == NULL) { /* no front, either */
	    q.front = newback;
	    newback->infront = NULL;
	}
	q.size++;
}

struct COVEN_TPH * COVEN_Dequeue_TPH(void)
{
	struct COVEN_TPH_Queue_Element *qe = q.front;
	struct COVEN_TPH *tph;
	if(qe == NULL) tph = NULL;
	else tph = qe->tph;
	if((qe->behind)!=NULL) {
	    /* 2nd in line becoming first in line */
	    (qe->behind)->infront = NULL; 
	    q.front = qe->behind;
	}
	else {
	    q.back = NULL;
	    q.front = NULL;
	}
	COVEN_free(qe);
	q.size--;
	return tph;
}
